# class Sass::Tree::RootNode

A static node that is the root node of the Sass document.

### Attributes

template[R]

The Sass template from which this node was created

@param template [String]

### Public Class Methods

new(template) click to toggle source

@param template [String] The Sass template from which this node was created

Calls superclass method Sass::Tree::Node.new

    # File lib/sass/tree/root_node.rb, line 11
    def initialize(template)
      super()
      @template = template
    end

### Public Instance Methods

render() click to toggle source

Runs the dynamic Sass code and computes the CSS for the tree.

@return [String] The compiled CSS.

    # File lib/sass/tree/root_node.rb, line 19
    def render
      css_tree.css
    end

render_with_sourcemap() click to toggle source

Runs the dynamic Sass code and computes the CSS for the tree, along with the sourcemap.

@return [(String, Sass::Source::Map)] The compiled CSS, as well as

    the source map. @see #render

    # File lib/sass/tree/root_node.rb, line 28
    def render_with_sourcemap
      css_tree.css_with_sourcemap
    end

### Private Instance Methods

css_tree() click to toggle source

    # File lib/sass/tree/root_node.rb, line 34
    def css_tree
      Visitors::CheckNesting.visit(self)
      result = Visitors::Perform.visit(self)
      Visitors::CheckNesting.visit(result) # Check again to validate mixins
      result, extends = Visitors::Cssize.visit(result)
      Visitors::Extend.visit(result, extends)
      result
    end